Open CASCADE Technology: Geom_SweptSurface Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Attributes
Geom_SweptSurface Class Reference

Describes the common behavior for surfaces constructed by sweeping a curve with another curve. The Geom package provides two concrete derived surfaces: surface of revolution (a revolved surface), and surface of linear extrusion (an extruded surface). More...

`#include <Geom_SweptSurface.hxx>`

Inheritance diagram for Geom_SweptSurface:
[legend]

## Public Member Functions
GeomAbs_Shape | Continuity () const
| returns the continuity of the surface : C0 : only geometric continuity, C1 : continuity of the first derivative all along the surface, C2 : continuity of the second derivative all along the surface, C3 : continuity of the third derivative all along the surface, G1 : tangency continuity all along the surface, G2 : curvature continuity all along the surface, CN : the order of continuity is infinite. More...
const gp_Dir & | Direction () const
| Returns the reference direction of the swept surface. For a surface of revolution it is the direction of the revolution axis, for a surface of linear extrusion it is the direction of extrusion. More...
Handle< Geom_Curve > | BasisCurve () const
| Returns the referenced curve of the surface. For a surface of revolution it is the revolution curve, for a surface of linear extrusion it is the extruded curve. More...
Public Member Functions inherited from Geom_Surface
virtual void | UReverse ()=0
| Reverses the U direction of parametrization of <me>. The bounds of the surface are not modified. More...
Handle< Geom_Surface > | UReversed () const
| Reverses the U direction of parametrization of <me>. The bounds of the surface are not modified. A copy of <me> is returned. More...
virtual Standard_Real | UReversedParameter (const Standard_Real U) const =0
| Returns the parameter on the Ureversed surface for the point of parameter U on <me>. More...
virtual void | VReverse ()=0
| Reverses the V direction of parametrization of <me>. The bounds of the surface are not modified. More...
Handle< Geom_Surface > | VReversed () const
| Reverses the V direction of parametrization of <me>. The bounds of the surface are not modified. A copy of <me> is returned. More...
virtual Standard_Real | VReversedParameter (const Standard_Real V) const =0
| Returns the parameter on the Vreversed surface for the point of parameter V on <me>. More...
virtual void | TransformParameters (Standard_Real &U, Standard_Real &V, const gp_Trsf &T) const
| Computes the parameters on the transformed surface for the transform of the point of parameters U,V on <me>. More...
virtual gp_GTrsf2d | ParametricTransformation (const gp_Trsf &T) const
| Returns a 2d transformation used to find the new parameters of a point on the transformed surface. More...
virtual void | Bounds (Standard_Real &U1, Standard_Real &U2, Standard_Real &V1, Standard_Real &V2) const =0
| Returns the parametric bounds U1, U2, V1 and V2 of this surface. If the surface is infinite, this function can return a value equal to Precision::Infinite: instead of Standard_Real::LastReal. More...
virtual Standard_Boolean | IsUClosed () const =0
| Checks whether this surface is closed in the u parametric direction. Returns true if, in the u parametric direction: taking uFirst and uLast as the parametric bounds in the u parametric direction, for each parameter v, the distance between the points P(uFirst, v) and P(uLast, v) is less than or equal to gp::Resolution(). More...
virtual Standard_Boolean | IsVClosed () const =0
| Checks whether this surface is closed in the u parametric direction. Returns true if, in the v parametric direction: taking vFirst and vLast as the parametric bounds in the v parametric direction, for each parameter u, the distance between the points P(u, vFirst) and P(u, vLast) is less than or equal to gp::Resolution(). More...
virtual Standard_Boolean | IsUPeriodic () const =0
| Checks if this surface is periodic in the u parametric direction. Returns true if: More...
virtual Standard_Real | UPeriod () const
| Returns the period of this surface in the u parametric direction. raises if the surface is not uperiodic. More...
virtual Standard_Boolean | IsVPeriodic () const =0
| Checks if this surface is periodic in the v parametric direction. Returns true if: More...
virtual Standard_Real | VPeriod () const
| Returns the period of this surface in the v parametric direction. raises if the surface is not vperiodic. More...
virtual Handle< Geom_Curve > | UIso (const Standard_Real U) const =0
| Computes the U isoparametric curve. More...
virtual Handle< Geom_Curve > | VIso (const Standard_Real V) const =0
| Computes the V isoparametric curve. More...
virtual Standard_Boolean | IsCNu (const Standard_Integer N) const =0
| Returns the order of continuity of the surface in the U parametric direction. Raised if N < 0. More...
virtual Standard_Boolean | IsCNv (const Standard_Integer N) const =0
| Returns the order of continuity of the surface in the V parametric direction. Raised if N < 0. More...
virtual void | D0 (const Standard_Real U, const Standard_Real V, gp_Pnt &P) const =0
| Computes the point of parameter U,V on the surface. More...
virtual void | D1 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V) const =0
| Computes the point P and the first derivatives in the directions U and V at this point. Raised if the continuity of the surface is not C1. More...
virtual void | D2 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV) const =0
| Computes the point P, the first and the second derivatives in the directions U and V at this point. Raised if the continuity of the surface is not C2. More...
virtual void | D3 (const Standard_Real U, const Standard_Real V, gp_Pnt &P, gp_Vec &D1U, gp_Vec &D1V, gp_Vec &D2U, gp_Vec &D2V, gp_Vec &D2UV, gp_Vec &D3U, gp_Vec &D3V, gp_Vec &D3UUV, gp_Vec &D3UVV) const =0
| Computes the point P, the first,the second and the third derivatives in the directions U and V at this point. Raised if the continuity of the surface is not C2. More...
virtual gp_Vec | DN (const Standard_Real U, const Standard_Real V, const Standard_Integer Nu, const Standard_Integer Nv) const =0
| —Purpose ; Computes the derivative of order Nu in the direction U and Nv in the direction V at the point P(U, V). More...
gp_Pnt | Value (const Standard_Real U, const Standard_Real V) const
| Computes the point of parameter U on the surface. More...
Public Member Functions inherited from Geom_Geometry
void | Mirror (const gp_Pnt &P)
| Performs the symmetrical transformation of a Geometry with respect to the point P which is the center of the symmetry. More...
void | Mirror (const gp_Ax1 &A1)
| Performs the symmetrical transformation of a Geometry with respect to an axis placement which is the axis of the symmetry. More...
void | Mirror (const gp_Ax2 &A2)
| Performs the symmetrical transformation of a Geometry with respect to a plane. The axis placement A2 locates the plane of the symmetry : (Location, XDirection, YDirection). More...
void | Rotate (const gp_Ax1 &A1, const Standard_Real Ang)
| Rotates a Geometry. A1 is the axis of the rotation. Ang is the angular value of the rotation in radians. More...
void | Scale (const gp_Pnt &P, const Standard_Real S)
| Scales a Geometry. S is the scaling value. More...
void | Translate (const gp_Vec &V)
| Translates a Geometry. V is the vector of the tanslation. More...
void | Translate (const gp_Pnt &P1, const gp_Pnt &P2)
| Translates a Geometry from the point P1 to the point P2. More...
virtual void | Transform (const gp_Trsf &T)=0
| Transformation of a geometric object. This tansformation can be a translation, a rotation, a symmetry, a scaling or a complex transformation obtained by combination of the previous elementaries transformations. (see class Transformation of the package Geom). More...
Handle< Geom_Geometry > | Mirrored (const gp_Pnt &P) const
Handle< Geom_Geometry > | Mirrored (const gp_Ax1 &A1) const
Handle< Geom_Geometry > | Mirrored (const gp_Ax2 &A2) const
Handle< Geom_Geometry > | Rotated (const gp_Ax1 &A1, const Standard_Real Ang) const
Handle< Geom_Geometry > | Scaled (const gp_Pnt &P, const Standard_Real S) const
Handle< Geom_Geometry > | Transformed (const gp_Trsf &T) const
Handle< Geom_Geometry > | Translated (const gp_Vec &V) const
Handle< Geom_Geometry > | Translated (const gp_Pnt &P1, const gp_Pnt &P2) const
virtual Handle< Geom_Geometry > | Copy () const =0
| Creates a new object which is a copy of this geometric object. More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Protected Attributes
Handle< Geom_Curve > | basisCurve
gp_Dir | direction
GeomAbs_Shape | smooth

## Detailed Description

Describes the common behavior for surfaces constructed by sweeping a curve with another curve. The Geom package provides two concrete derived surfaces: surface of revolution (a revolved surface), and surface of linear extrusion (an extruded surface).

## Member Function Documentation

Handle< Geom_Curve > Geom_SweptSurface::BasisCurve | ( |  | ) | const

Returns the referenced curve of the surface. For a surface of revolution it is the revolution curve, for a surface of linear extrusion it is the extruded curve.

GeomAbs_Shape Geom_SweptSurface::Continuity | ( |  | ) | const
| virtual

returns the continuity of the surface : C0 : only geometric continuity, C1 : continuity of the first derivative all along the surface, C2 : continuity of the second derivative all along the surface, C3 : continuity of the third derivative all along the surface, G1 : tangency continuity all along the surface, G2 : curvature continuity all along the surface, CN : the order of continuity is infinite.

Implements Geom_Surface.

const gp_Dir& Geom_SweptSurface::Direction | ( |  | ) | const

Returns the reference direction of the swept surface. For a surface of revolution it is the direction of the revolution axis, for a surface of linear extrusion it is the direction of extrusion.

## Field Documentation

Handle< Geom_Curve > Geom_SweptSurface::basisCurve
| protected

gp_Dir Geom_SweptSurface::direction
| protected

GeomAbs_Shape Geom_SweptSurface::smooth
| protected

The documentation for this class was generated from the following file:

- Geom_SweptSurface.hxx